//+------------------------------------------------------------------+
//|                                                  Lukyanov_AT.mq4 |
//|                                Copyright  2007, Sergey Lukyanov |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Lukyanov S.V."

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

extern double lot_trade = 1;
extern int Tral_Stop=15;
extern int Tral_Profit = 15;
extern int max_trade = 0.03;

string Instrument[26]; 

double Mas_Ord_Tek[26][31][8], Mas_Ord_Old[26][31][8]; //     

                                 // 1  =    
                                 // 2  =    ..
                                 // ..    
                                 // [][][0]  
                                 // [][][1]  .    ( . )
                                 // [][][2] StopLoss      ( . )
                                 // [][][3] TakeProfit    ( . )
                                 // [][][4]          
                                 // [][][5] .   ( . )
                                 // [][][6]   1=B,2=S,3=BL,4=SL,5=BS,6=SS
                                 // [][][7]   


int trade = 1;


int init()
{
   Instrument[1] = "EURUSD";
   Instrument[2] = "AUDCAD";
   Instrument[3] = "AUDCHF";
   Instrument[4] = "AUDJPY";
   Instrument[5] = "AUDNZD";
   Instrument[6] = "AUDUSD";
   Instrument[7] = "CADCHF";
   Instrument[8] = "CADJPY";
   Instrument[9] = "CHFJPY";
   Instrument[10] = "EURAUD";
   Instrument[11] = "EURCAD";
   Instrument[12] = "EURCHF";
   Instrument[13] = "EURGBP";
   Instrument[14] = "EURJPY";
   Instrument[15] = "EURNZD";
   Instrument[16] = "EURUSD";
   Instrument[17] = "GBPCHF";
   Instrument[18] = "GBPJPY";
   Instrument[19] = "GBPUSD";
   Instrument[20] = "NZDJPY";
   Instrument[21] = "NZDUSD";
   Instrument[22] = "USDCAD";
   Instrument[23] = "USDCHF";
   Instrument[24] = "USDJPY";
    
   return(0);  
}



//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+


int start()
  {
//----

double signal1=iCustom(NULL,0,"Ind1",0,0);
double signal2=iCustom(NULL,0,"Ind2",0,0);
double signal3=iCustom(NULL,0,"Ind3",0,0);
double signal4=iCustom(NULL,0,"Ind4",0,0);
    
trade = 1;    
//==============================================  =
   ArrayCopy(Mas_Ord_Old, Mas_Ord_Tek); //   
   ArrayInitialize(Mas_Ord_Tek,0);  //    .
//===============================================   =
   for (int i=0; i<OrdersTotal(); i++)//    
      {
      if(OrderSelect(i, SELECT_BY_POS)==true) //     
         {
//--------------------     -
         string Symb=OrderSymbol(); //    
         for (int ind=1; ind<=25; ind++) //    . .
            {
            if (Symb==Instrument[ind]) //  ,  
               trade = 0; //  
               break; //     ind
            }
//----------------------     ----
         Mas_Ord_Tek[0][0][0]++; //    
         Mas_Ord_Tek[ind][0][0]++; //  ..  .
         int k=Mas_Ord_Tek[ind][0][0]; //  
         
         Mas_Ord_Tek[ind][k][1] = NormalizeDouble(OrderOpenPrice(), Digits); //  . 
         Mas_Ord_Tek[ind][k][2] = NormalizeDouble(OrderStopLoss(), Digits); //  SL
         Mas_Ord_Tek[ind][k][3] = NormalizeDouble(OrderTakeProfit(), Digits); //  
         Mas_Ord_Tek[ind][k][4] = OrderTicket(); //  
         Mas_Ord_Tek[ind][k][5] = OrderLots();   // . 
         Mas_Ord_Tek[ind][k][6] = OrderType();   //  
         Mas_Ord_Tek[ind][k][7] = OrderMagicNumber(); //   
         
//-----------------------------------------------------------------
         }
      }
//=================================================================

if (trade == 1)
{
   if (signal1>80)
   if (signal2>0)  
   if (signal3>0)
   if (signal4>0)   
    {  
     OrderSend(Symbol(),OP_BUY,lot_trade,Ask,3,Bid-50*Point,Ask+50*Point,"Lukyanov AutoTrader BUY",0,0,Blue);
     OrderPrint();  
     Print("  : ",GetLastError());

    } 

   if (signal1<20)
   if (signal2==0) 
   if (signal3<0)
   if (signal4<0) 
    { 
     OrderSend(Symbol(),OP_SELL,lot_trade,Ask,3,Bid+50*Point,Ask-50*Point,"Lukyanov AutoTrader SELL",0,0,Red);
     OrderPrint(); 
     Print("  : ",GetLastError());
    }
}

double Profit_buy = (Bid-OrderOpenPrice())/Point;
double Profit_sell = (OrderOpenPrice()-Ask)/Point;

//--------------------------------------------------------------- 2 --
   for(int it=1; it<=OrdersTotal(); it++)          //   
     {
      if (OrderSelect(it-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         int Tip=OrderType();                   //  
         if(OrderSymbol()!=Symb||Tip>1)continue;//   
         double SL=OrderStopLoss();             // SL  .
         //------------------------------------------------------ 3 --
         while(true)                            //  
           {
            double TS=Tral_Stop;                //  
            int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);//. 
            if (TS < Min_Dist)                  //   .
               TS=Min_Dist;                     //   TS
            //--------------------------------------------------- 4 --
            bool Modify=false;                  //    
            switch(Tip)                         //   
              {
               case 0 :                         //  Buy
                  if (Profit_buy > Tral_Profit)
                   if (NormalizeDouble(SL,Digits)< NormalizeDouble(Bid-TS*Point,Digits))
                    {
                     SL=Bid-TS*Point;           //   
                     string Text="Buy ";        //   Buy 
                     Modify=true;               //   .
                    }
                  break;                        //   switch
               case 1 :
                 if (Profit_sell > Tral_Profit)          //  Sell
                  if (NormalizeDouble(SL,Digits)> NormalizeDouble(Ask+TS*Point,Digits) || NormalizeDouble(SL,Digits)==0)//  
                    {
                     SL=Ask+TS*Point;           //   
                     Text="Sell ";              //   Sell 
                     Modify=true;               //   .
                    }
              }                                 //  switch
            if (Modify==false)                  //    
               break;                           //   while
            //--------------------------------------------------- 5 --
            double TP    =OrderTakeProfit();    // TP  .
            double Price =OrderOpenPrice();     //  . .
            int    Ticket=OrderTicket();        //  . .
 
            Alert (" ",Text,Ticket,".  ..");
            bool Ans=OrderModify(Ticket,Price,SL,TP,0);// !
            //--------------------------------------------------- 6 --
            if (Ans==true)                      //  :)
              {
               Alert (" ",Text,Ticket," :)");
               break;                           //   .
              }
            //--------------------------------------------------- 7 --
            int Error=GetLastError();           //   :(
            switch(Error)                       //  
              {
               case 130:Alert(" .   .");
                  RefreshRates();               //  
                  continue;                     //  . 
               case 136:Alert(" .   ..");
                  while(RefreshRates()==false)  //   
                     Sleep(1);                  //   
                  continue;                     //  . 
               case 146:Alert("  . ");
                  Sleep(500);                   //  
                  RefreshRates();               //  
                  continue;                     //  . 
                  //  
               case 2 : Alert(" .");
                  break;                        //   switch
               case 5 : Alert("   .");
                  break;                        //   switch
               case 64: Alert(" .");
                  break;                        //   switch
               case 133:Alert(" ");
                  break;                        //   switch
               default: Alert("  ",Error);//. 
              }
            break;                              //   .
           }                                    //   .
         //------------------------------------------------------ 8 --
        }                                       //   .
     }                                          //   .
     
   return(0);
}
//+------------------------------------------------------------------+

/*

2008.01.04 20:39:46	Lukyanov_AT EURJPY,M15:   : 129
2008.01.04 20:39:46	Lukyanov_AT EURJPY,M15: #18706506 2008.01.04 14:30 sell 1.00 USDCHF 1.1076 1.1076 1.1026 1.1060 0.00 0.00 144.67 Lukyanov AutoTrader SELL 0
2008.01.04 20:39:46	Lukyanov_AT CADJPY,M15:   : 129
2008.01.04 20:39:46	Lukyanov_AT CADJPY,M15: #18706506 2008.01.04 14:30 sell 1.00 USDCHF 1.1076 1.1076 1.1026 1.1060 0.00 0.00 144.67 Lukyanov AutoTrader SELL 0
2008.01.04 20:39:46	Lukyanov_AT GBPJPY,M15:   : 129
2008.01.04 20:39:46	Lukyanov_AT GBPJPY,M15: #18706506 2008.01.04 14:30 sell 1.00 USDCHF 1.1076 1.1076 1.1026 1.1060 0.00 0.00 144.67 Lukyanov AutoTrader SELL 0


*/